UNIQUE function

The UNIQUE function returns a list of unique values in a list or range.

Description
app.js
index.html
styles.css
Copy to CodeMine

The UNIQUE function returns a list of unique values in a list or range. For example:

=UNIQUE(array, by_col?, occurs_once?) 
Argument Required Description
array Y The range or array from which to return unique values
[by_col] N Is a logical value indicating how to compare; By row = false or omitted; By column = true
[occurs_once] N Is a logical value: only return unique values that occur once = true; include all unique values = false or omitted

Note:

  • The UNIQUE function is only valid when allowDynamicArray is true.
  • The UNIQUE function will return an array, which will spill if it's the final result of a formula.
  • An array can be thought of as a row of values, a column of values, or a combination of rows and columns of values.
The UNIQUE function returns a list of unique values in a list or range. For example: Argument Required Description array Y The range or array from which to return unique values [by_col] N Is a logical value indicating how to compare; By row = false or omitted; By column = true [occurs_once] N Is a logical value: only return unique values that occur once = true; include all unique values = false or omitted Note: The UNIQUE function is only valid when allowDynamicArray is true. The UNIQUE function will return an array, which will spill if it's the final result of a formula. An array can be thought of as a row of values, a column of values, or a combination of rows and columns of values.
window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(_getElementById("ss")); initSpread(spread); }; var demoData = [ ["Region","Sales Rep","Product","Units"], ["East","Tom","Apple",6380], ["West","Fred","Grape", 5619], ["North ","Amy","Pear", 4565], ["South","Sal","Banana", 5323], ["East","Fritz","Apple", 4394], ["West","Sravan","Grape", 7195], ["North ","Xi","Pear", 5231], ["South","Hector","Banana", 2427], ["East","Tom","Banana", 4213], ["West","Fred","Pear", 3239], ["North ","Amy","Grape", 6420], ["South","Sal","Apple", 1310], ["East","Fritz","Banana", 6274], ["West","Sravan","Pear", 4894], ["North ","Xi","Grape", 7580], ["South","Hector","Apple", 9814] ]; function initSpread(spread) { spread.options.allowDynamicArray = true; var sheet = spread.getActiveSheet(); spread.suspendPaint(); spread.suspendCalcService(); sheet.name('UNIQUE'); sheet.defaults.colWidth = 80; sheet.setColumnWidth(0, 20); sheet.setColumnWidth(5, 20); sheet.setColumnWidth(9, 20); sheet.setText(0, 1, 'Use the UNIQUE function to return a unique list from a range or array of items. Syntax: UNIQUE(array,[by_col],[occurs_once])'); var row = 2; var col = 1; var col2 = col + 5; var rowCount = 16; applyTableStyleForRange(sheet, row, col, rowCount + 1, 4); applyTableStyleForRange(sheet, row, col + 5, 10, 3); applyTableStyleForRange(sheet, row, col2 + 4, rowCount + 1, 4); sheet.setArray(row, col, demoData); sheet.setText(row - 1, col2, "Unique values:"); sheet.setArray(row, col2, [["Region","Sales Rep","Product","", "Region","Sales Rep","Product","Units"]]); row++; sheet.setFormula(row, col2, 'UNIQUE(B4:B19)'); sheet.setFormula(row, col2 + 1, 'UNIQUE(C4:C19)'); sheet.setFormula(row, col2 + 2, 'UNIQUE(D4:D19)'); col2 += 4; sheet.setText(row - 2, col2, "Unique values in order by SORT"); sheet.setFormula(row, col2, 'SORT(UNIQUE(B4:B19))'); sheet.setFormula(row, col2 + 1, 'SORT(UNIQUE(C4:C19))'); sheet.setFormula(row, col2 + 2, 'SORT(UNIQUE(D4:D19))'); sheet.setFormula(row, col2 + 3, 'SORT(UNIQUE(E4:E19))'); var formatter = '#,##0'; sheet.getRange(row, col + 3, rowCount, 1).formatter(formatter); sheet.getRange(row, col2 + 3, rowCount, 1).formatter(formatter); spread.resumeCalcService(); spread.resumePaint(); } function applyTableStyleForRange(sheet, row, col, rowCount, colCount, options) { var tableName = "tmpTable"; var TableThemes = GC.Spread.Sheets.Tables.TableThemes; // use table to help set style then remove like convert table to range in Excel sheet.tables.add(tableName, row, col, rowCount, colCount, TableThemes.medium7, options); sheet.tables.remove(tableName, 2 /* keep style */); } function _getElementById(id) { return document.getElementById(id); }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" style="width:100%; height: 100%"></div> </div></body> </html>
.sample { position: relative; height: 100%; overflow: auto; } .sample::after { display: block; content: ""; clear: both; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } .option-group { margin-bottom: 6px; } label { display: block; margin-bottom: 6px; } input { margin-bottom: 5px; padding: 2px 4px; width: 100%; box-sizing: border-box; } input[type=button] { margin-bottom: 6px; } hr { border-color: #fff; opacity: .2; margin: 5px 0; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }

The UNIQUE function returns a list of unique values in a list or range. For example:
Argument
Required
Description
array
Y
The range or array from which to return unique values
[by_col]
N
Is a logical value indicating how to compare; By row = false or omitted; By column = true
[occurs_once]
N
Is a logical value: only return unique values that occur once = true; include all unique values = false or omitted
Note:
The UNIQUE function is only valid when allowDynamicArray is true.
The UNIQUE function will return an array, which will spill if it's the final result of a formula.
An array can be thought of as a row of values, a column of values, or a combination of rows and columns of values.
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const demoData = [
["Region", "Sales Rep", "Product", "Units"],
["East", "Tom", "Apple", 6380],
["West", "Fred", "Grape", 5619],
["North ", "Amy", "Pear", 4565],
["South", "Sal", "Banana", 5323],
["East", "Fritz", "Apple", 4394],
["West", "Sravan", "Grape", 7195],
["North ", "Xi", "Pear", 5231],
["South", "Hector", "Banana", 2427],
["East", "Tom", "Banana", 4213],
["West", "Fred", "Pear", 3239],
["North ", "Amy", "Grape", 6420],
["South", "Sal", "Apple", 1310],
["East", "Fritz", "Banana", 6274],
["West", "Sravan", "Pear", 4894],
["North ", "Xi", "Grape", 7580],
["South", "Hector", "Apple", 9814]
];
export function AppFunc() {
const initSpread = (spread) => {
spread.options.allowDynamicArray = true;
var sheet = spread.getActiveSheet();
spread.suspendPaint();
spread.suspendCalcService();
sheet.name('UNIQUE');
sheet.defaults.colWidth = 80;
sheet.setColumnWidth(0, 20);
sheet.setColumnWidth(5, 20);
sheet.setColumnWidth(9, 20);
sheet.setText(0, 1, 'Use the UNIQUE function to return a unique list from a range or array of items. Syntax: UNIQUE(array,[by_col],[occurs_once])');
var row = 2;
var col = 1;
var col2 = col + 5;
var rowCount = 16;
applyTableStyleForRange(sheet, row, col, rowCount + 1, 4);
applyTableStyleForRange(sheet, row, col + 5, 10, 3);
applyTableStyleForRange(sheet, row, col2 + 4, rowCount + 1, 4);
sheet.setArray(row, col, demoData);
sheet.setText(row - 1, col2, "Unique values:");
sheet.setArray(row, col2, [["Region", "Sales Rep", "Product", "", "Region", "Sales Rep", "Product", "Units"]]);
row++;
sheet.setFormula(row, col2, 'UNIQUE(B4:B19)');
sheet.setFormula(row, col2 + 1, 'UNIQUE(C4:C19)');
sheet.setFormula(row, col2 + 2, 'UNIQUE(D4:D19)');
col2 += 4;
sheet.setText(row - 2, col2, "Unique values in order by SORT");
sheet.setFormula(row, col2, 'SORT(UNIQUE(B4:B19))');
sheet.setFormula(row, col2 + 1, 'SORT(UNIQUE(C4:C19))');
sheet.setFormula(row, col2 + 2, 'SORT(UNIQUE(D4:D19))');
sheet.setFormula(row, col2 + 3, 'SORT(UNIQUE(E4:E19))');
var formatter = '#,##0';
sheet.getRange(row, col + 3, rowCount, 1).formatter(formatter);
sheet.getRange(row, col2 + 3, rowCount, 1).formatter(formatter);
spread.resumeCalcService();
spread.resumePaint();
}
const applyTableStyleForRange = (sheet, row, col, rowCount, colCount, options) => {
var tableName = "tmpTable";
var TableThemes = GC.Spread.Sheets.Tables.TableThemes;
// use table to help set style then remove like convert table to range in Excel
sheet.tables.add(tableName, row, col, rowCount, colCount, TableThemes.medium7, options);
sheet.tables.remove(tableName, 2 /* keep style */);
}
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
</div>;
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
const demoData = [
["Region","Sales Rep","Product","Units"],
["East","Tom","Apple",6380],
["West","Fred","Grape", 5619],
["North ","Amy","Pear", 4565],
["South","Sal","Banana", 5323],
["East","Fritz","Apple", 4394],
["West","Sravan","Grape", 7195],
["North ","Xi","Pear", 5231],
["South","Hector","Banana", 2427],
["East","Tom","Banana", 4213],
["West","Fred","Pear", 3239],
["North ","Amy","Grape", 6420],
["South","Sal","Apple", 1310],
["East","Fritz","Banana", 6274],
["West","Sravan","Pear", 4894],
["North ","Xi","Grape", 7580],
["South","Hector","Apple", 9814]
];
export class App extends Component {
render() {
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread=>this.initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
</div>;
}
initSpread(spread) {
spread.options.allowDynamicArray = true;
var sheet = spread.getActiveSheet();
spread.suspendPaint();
spread.suspendCalcService();
sheet.name('UNIQUE');
sheet.defaults.colWidth = 80;
sheet.setColumnWidth(0, 20);
sheet.setColumnWidth(5, 20);
sheet.setColumnWidth(9, 20);
sheet.setText(0, 1, 'Use the UNIQUE function to return a unique list from a range or array of items. Syntax: UNIQUE(array,[by_col],[occurs_once])');
var row = 2;
var col = 1;
var col2 = col + 5;
var rowCount = 16;
this.applyTableStyleForRange(sheet, row, col, rowCount + 1, 4);
this.applyTableStyleForRange(sheet, row, col + 5, 10, 3);
this.applyTableStyleForRange(sheet, row, col2 + 4, rowCount + 1, 4);
sheet.setArray(row, col, demoData);
sheet.setText(row - 1, col2, "Unique values:");
sheet.setArray(row, col2, [["Region","Sales Rep","Product","", "Region","Sales Rep","Product","Units"]]);
row++;
sheet.setFormula(row, col2, 'UNIQUE(B4:B19)');
sheet.setFormula(row, col2 + 1, 'UNIQUE(C4:C19)');
sheet.setFormula(row, col2 + 2, 'UNIQUE(D4:D19)');
col2 += 4;
sheet.setText(row - 2, col2, "Unique values in order by SORT");
sheet.setFormula(row, col2, 'SORT(UNIQUE(B4:B19))');
sheet.setFormula(row, col2 + 1, 'SORT(UNIQUE(C4:C19))');
sheet.setFormula(row, col2 + 2, 'SORT(UNIQUE(D4:D19))');
sheet.setFormula(row, col2 + 3, 'SORT(UNIQUE(E4:E19))');
var formatter = '#,##0';
sheet.getRange(row, col + 3, rowCount, 1).formatter(formatter);
sheet.getRange(row, col2 + 3, rowCount, 1).formatter(formatter);
spread.resumeCalcService();
spread.resumePaint();
}
applyTableStyleForRange(sheet, row, col, rowCount, colCount, options) {
var tableName = "tmpTable";
var TableThemes = GC.Spread.Sheets.Tables.TableThemes;
// use table to help set style then remove like convert table to range in Excel
sheet.tables.add(tableName, row, col, rowCount, colCount, TableThemes.medium7, options);
sheet.tables.remove(tableName, 2 /* keep style */);
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
#switchAutoMergeMode {
margin: 10px 0px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

The UNIQUE function returns a list of unique values in a list or range. For example:
Argument
Required
Description
array
Y
The range or array from which to return unique values
[by_col]
N
Is a logical value indicating how to compare; By row = false or omitted; By column = true
[occurs_once]
N
Is a logical value: only return unique values that occur once = true; include all unique values = false or omitted
Note:
The UNIQUE function is only valid when allowDynamicArray is true.
The UNIQUE function will return an array, which will spill if it's the final result of a formula.
An array can be thought of as a row of values, a column of values, or a combination of rows and columns of values.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
function initSpread (spread) {
const demoData = [
["Region","Sales Rep","Product","Units"],
["East","Tom","Apple",6380],
["West","Fred","Grape", 5619],
["North ","Amy","Pear", 4565],
["South","Sal","Banana", 5323],
["East","Fritz","Apple", 4394],
["West","Sravan","Grape", 7195],
["North ","Xi","Pear", 5231],
["South","Hector","Banana", 2427],
["East","Tom","Banana", 4213],
["West","Fred","Pear", 3239],
["North ","Amy","Grape", 6420],
["South","Sal","Apple", 1310],
["East","Fritz","Banana", 6274],
["West","Sravan","Pear", 4894],
["North ","Xi","Grape", 7580],
["South","Hector","Apple", 9814]
];
spread.options.allowDynamicArray = true;
var sheet = spread.getActiveSheet();
spread.suspendPaint();
spread.suspendCalcService();
sheet.name('UNIQUE');
sheet.defaults.colWidth = 80;
sheet.setColumnWidth(0, 20);
sheet.setColumnWidth(5, 20);
sheet.setColumnWidth(9, 20);
sheet.setText(0, 1, 'Use the UNIQUE function to return a unique list from a range or array of items. Syntax: UNIQUE(array,[by_col],[occurs_once])');
var row = 2;
var col = 1;
var col2 = col + 5;
var rowCount = 16;
applyTableStyleForRange(sheet, row, col, rowCount + 1, 4);
applyTableStyleForRange(sheet, row, col + 5, 10, 3);
applyTableStyleForRange(sheet, row, col2 + 4, rowCount + 1, 4);
sheet.setArray(row, col, demoData);
sheet.setText(row - 1, col2, "Unique values:");
sheet.setArray(row, col2, [["Region","Sales Rep","Product","", "Region","Sales Rep","Product","Units"]]);
row++;
sheet.setFormula(row, col2, 'UNIQUE(B4:B19)');
sheet.setFormula(row, col2 + 1, 'UNIQUE(C4:C19)');
sheet.setFormula(row, col2 + 2, 'UNIQUE(D4:D19)');
col2 += 4;
sheet.setText(row - 2, col2, "Unique values in order by SORT");
sheet.setFormula(row, col2, 'SORT(UNIQUE(B4:B19))');
sheet.setFormula(row, col2 + 1, 'SORT(UNIQUE(C4:C19))');
sheet.setFormula(row, col2 + 2, 'SORT(UNIQUE(D4:D19))');
sheet.setFormula(row, col2 + 3, 'SORT(UNIQUE(E4:E19))');
var formatter = '#,##0';
sheet.getRange(row, col + 3, rowCount, 1).formatter(formatter);
sheet.getRange(row, col2 + 3, rowCount, 1).formatter(formatter);
spread.resumeCalcService();
spread.resumePaint();
}
function applyTableStyleForRange (sheet, row, col, rowCount, colCount, options) {
var tableName = "tmpTable";
var TableThemes = GC.Spread.Sheets.Tables.TableThemes;
// use table to help set style then remove like convert table to range in Excel
sheet.tables.add(tableName, row, col, rowCount, colCount, TableThemes.medium7, options);
sheet.tables.remove(tableName, 2 /* keep style */);
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
#switchAutoMergeMode {
margin: 10px 0px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html lang="en" style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

The UNIQUE function returns a list of unique values in a list or range. For example:
Argument
Required
Description
array
Y
The range or array from which to return unique values
[by_col]
N
Is a logical value indicating how to compare; By row = false or omitted; By column = true
[occurs_once]
N
Is a logical value: only return unique values that occur once = true; include all unique values = false or omitted
Note:
The UNIQUE function is only valid when allowDynamicArray is true.
The UNIQUE function will return an array, which will spill if it's the final result of a formula.
An array can be thought of as a row of values, a column of values, or a combination of rows and columns of values.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: '100%',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
const demoData = [
["Region","Sales Rep","Product","Units"],
["East","Tom","Apple",6380],
["West","Fred","Grape", 5619],
["North ","Amy","Pear", 4565],
["South","Sal","Banana", 5323],
["East","Fritz","Apple", 4394],
["West","Sravan","Grape", 7195],
["North ","Xi","Pear", 5231],
["South","Hector","Banana", 2427],
["East","Tom","Banana", 4213],
["West","Fred","Pear", 3239],
["North ","Amy","Grape", 6420],
["South","Sal","Apple", 1310],
["East","Fritz","Banana", 6274],
["West","Sravan","Pear", 4894],
["North ","Xi","Grape", 7580],
["South","Hector","Apple", 9814]
];
spread.options.allowDynamicArray = true;
let sheet = spread.getActiveSheet();
spread.suspendPaint();
spread.suspendCalcService();
sheet.name('UNIQUE');
sheet.defaults.colWidth = 80;
sheet.setColumnWidth(0, 20);
sheet.setColumnWidth(5, 20);
sheet.setColumnWidth(9, 20);
sheet.setText(0, 1, 'Use the UNIQUE function to return a unique list from a range or array of items. Syntax: UNIQUE(array,[by_col],[occurs_once])');
let row = 2;
let col = 1;
let col2 = col + 5;
let rowCount = 16;
this.applyTableStyleForRange(sheet, row, col, rowCount + 1, 4);
this.applyTableStyleForRange(sheet, row, col + 5, 10, 3);
this.applyTableStyleForRange(sheet, row, col2 + 4, rowCount + 1, 4);
sheet.setArray(row, col, demoData);
sheet.setText(row - 1, col2, "Unique values:");
sheet.setArray(row, col2, [["Region","Sales Rep","Product","", "Region","Sales Rep","Product","Units"]]);
row++;
sheet.setFormula(row, col2, 'UNIQUE(B4:B19)');
sheet.setFormula(row, col2 + 1, 'UNIQUE(C4:C19)');
sheet.setFormula(row, col2 + 2, 'UNIQUE(D4:D19)');
col2 += 4;
sheet.setText(row - 2, col2, "Unique values in order by SORT");
sheet.setFormula(row, col2, 'SORT(UNIQUE(B4:B19))');
sheet.setFormula(row, col2 + 1, 'SORT(UNIQUE(C4:C19))');
sheet.setFormula(row, col2 + 2, 'SORT(UNIQUE(D4:D19))');
sheet.setFormula(row, col2 + 3, 'SORT(UNIQUE(E4:E19))');
let formatter = '#,##0';
sheet.getRange(row, col + 3, rowCount, 1).formatter(formatter);
sheet.getRange(row, col2 + 3, rowCount, 1).formatter(formatter);
spread.resumeCalcService();
spread.resumePaint();
}
applyTableStyleForRange(sheet: GC.Spread.Sheets.Worksheet, row: number, col: number, rowCount: number, colCount:number, options?: any) {
let tableName = "tmpTable";
let TableThemes = GC.Spread.Sheets.Tables.TableThemes;
// use table to help set style then remove like convert table to range in Excel
sheet.tables.add(tableName, row, col, rowCount, colCount, TableThemes.medium7, options);
sheet.tables.remove(tableName, 2 /* keep style */);
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);